config/routes.rb
Moocchat::Application.routes.draw do
  mount JasmineRails::Engine => '/specs' if defined?(JasmineRails)

  resources :conditions
  resources :activity_schemas
  resources :questions
  resources :templates

  root :to => 'tasks#static', :as => 'root'

  get '/group_formation_times/:activity_schema_id/:condition_id' =>
    'waiting_rooms#group_formation_times'

  get '/seconds_to_next_group_formation/:activity_schema_id/' =>
    'waiting_rooms#seconds_to_next_group_formation'

  get '/get_current_timestamp_utc/' =>
    'waiting_rooms#get_current_timestamp_utc'

  match '/auth/:provider/callback', :to => 'sessions#try_login'
  get '/auth/failure', :to => 'sessions#login_failed'
  post '/logout', :to => 'sessions#destroy'

  post '/tasks/:learner_name/:activity_schema_id/:condition_id' => 'tasks#create', :as => 'task_create'
  post '/tasks' => 'tasks#create' # regular form posting
  get '/tasks/turk/:condition_id' => 'tasks#create_turk' # entry point for Turk workers

  post '/tasks/:id/force_continue', :to => 'tasks#force_continue', :as => 'task_force_continue'

  post '/tasks/:id/disconnect', :to => 'tasks#disconnect', :as => 'task_disconnect'

  post '/tasks/:id/heartbeat', :to => 'tasks#heartbeat', :as => 'task_heartbeat'

  get '/tasks/error', :to => 'tasks#error', :as => 'task_error'

  get '/tasks/:id', :to => 'tasks#welcome', :as => 'task_welcome'

  post '/tasks/:id/join_group', :to => 'tasks#join_group', :as => 'task_join_group'

  get '/tasks/:id/complete', :to => 'tasks#complete', :as => 'task_complete'

  get '/tasks/:id/page', :to => 'tasks#page', :as => 'task_page'

  post '/tasks/:id/collect_response', :to => 'tasks#collect_response', :as => 'task_collect_response'

  post '/tasks/:id/next_page', :to => 'tasks#next_page', :as => 'task_next_page'

  post '/tasks/:id/log', :to => 'tasks#log', :as => 'task_log_event'

  get "users/record_consent"
  get "users/check_consent"

  get '/reports/chatlog' => 'reports#chatlog'
  post '/reports/chatlog/show' => 'reports#chatlog_show'
  get '/reports/sessions' => 'reports#sessions'
  post '/reports/sessions/show' => 'reports#sessions_show'

end

app/models/activity_schema.rb
class ActivitySchema < ActiveRecord::Base
  include HasManyInline
  has_many :tasks
  has_many :event_logs

  belongs_to :cohort

  # Minimum interval between experiment starts, in minutes
  MINIMUM_INTERVAL_BETWEEN_EXPERIMENTS = 1

  # Human friendly name for the activity schema.
  attr_accessible :name
  validates_presence_of :name

  attr_accessible :cohort,:randomized,:tag, :cohort_id

  attr_accessible :questions
  has_many_inline :questions, :class_name => :question
  validates_presence_of :questions

  attr_accessible :num_questions
  validates_numericality_of :num_questions, :greater_than => 0
  validate :num_questions, :size_must_equal_question

  # Boolean attribute: whether this activity is enabled (open for business)
  # TBD: Is this obsoleted by having the start and end times?
  attr_accessible :enabled

  # Earliest time someone can try to start the activity.  Must align on an activity boundary,
  # e.g. if the activity begins every 12 minutes, start time must be at :00, :12, :24, etc.
  attr_accessible :start_time
  validates :start_time, :date => true
  validate :start_time, :must_align_on_activity_boundary

  # Latest time someone can try to start the activity
  attr_accessible :end_time
  validates(:end_time,
    :date => {
      :after => lambda { |activity| activity.start_time },
      :message => 'must be later than start time'
    })

  # How often in minutes the activity restarts.  Must be greater than the minimum interval between
  # experiments, and must divide evenly into 60 minutes.
  attr_accessible :starts_every
  validates_numericality_of(:starts_every,
    :only_integer => true,
    :greater_than_or_equal_to => MINIMUM_INTERVAL_BETWEEN_EXPERIMENTS)
  validate :starts_every_must_divide_into_60

  private
  
  def starts_every_must_divide_into_60
    return if starts_every.to_i.zero? # another validation will catch this.
    errors.add(:starts_every, 'must divide evenly into 60') unless (60 % starts_every.to_i == 0)
  end

  def must_align_on_activity_boundary
    return if starts_every.to_i.zero? || start_time.nil? # other validations will catch these
    errors.add(:start_time,
      "must align with an activity boundary (:00, :#{'%02d' % starts_every}, :#{'%02d' % (2*starts_every)}, etc.)") unless start_time.min % starts_every.to_i == 0
  end

  def size_must_equal_question
    errors.add(:num_questions, "must match with the number of questions you selected") unless questions.size == num_questions
  end

  public

  # Compute next group formation time for this activity.
  # The +ActivitySchema+ knows the start and end times and how often the waiting rooms empty.
  # Since the repeat interval must be an integral divisor of 60 minutes, we just set the
  # expiration time to round *strictly up* to the nearest minute-boundary of a repeat, that is,
  # if the repeat is every 6 minutes and it's currently 16 after the hour, round up to 18.
  def compute_expiration_time
    repeat = self.starts_every
    minutes_to_add = repeat - (Time.zone.now.min % repeat)
    (Time.zone.now + minutes_to_add.minutes).change(:sec => 0)
  end

end

app/controllers/activity_schemas_controller.rb
class ActivitySchemasController < ApplicationController
  include QuestionHelper
  # GET /activity_schemas
  # GET /activity_schemas.json
  def index
    @activity_schemas = ActivitySchema.all

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @activity_schemas }
    end
  end

  # GET /activity_schemas/1
  # GET /activity_schemas/1.json
  def show
    @activity_schema = ActivitySchema.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @activity_schema }
    end
  end

  # GET /activity_schemas/new
  # GET /activity_schemas/new.json
  def new
    @activity_schema = ActivitySchema.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @activity_schema }
    end
  end

  # GET /activity_schemas/1/edit
  def edit
    @activity_schema = ActivitySchema.find(params[:id])
  end

  # POST /activity_schemas
  # POST /activity_schemas.json
  def create
    @question=params[:activity_schema][:questions]
    params[:activity_schema][:questions] = array_for(@question) unless @question == nil
    @activity_schema = ActivitySchema.new(params[:activity_schema])

    respond_to do |format|
      if @activity_schema.save
        format.html { redirect_to @activity_schema, notice: 'Activity schema was successfully created.' }
        format.json { render json: @activity_schema, status: :created, location: @activity_schema }
      else
        format.html { render action: "new" }
        format.json { render json: @activity_schema.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /activity_schemas/1
  # PUT /activity_schemas/1.json
  def update
    @activity_schema = ActivitySchema.find(params[:id])

    respond_to do |format|
      @question=params[:activity_schema][:questions]
      params[:activity_schema][:questions] = array_for(@question) unless @question == nil
      if @activity_schema.update_attributes(params[:activity_schema])
        format.html { redirect_to @activity_schema, notice: 'Activity schema was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @activity_schema.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /activity_schemas/1
  # DELETE /activity_schemas/1.json
  def destroy
    @activity_schema = ActivitySchema.find(params[:id])
    @activity_schema.destroy

    respond_to do |format|
      format.html { redirect_to activity_schemas_url }
      format.json { head :no_content }
    end
  end
end

app/views/activity_schemas/_form.html.haml
.notice
  - if @activity_schema.errors.any?
    = @activity_schema.errors.full_messages.join(', ')

= form_for @activity_schema, :html => { :class => 'form-horizontal' } do |f| 
  .control-group
    = f.label :cohort_id, :class => 'control-label' 
    .controls= f.number_field :cohort_id, :class => 'number_field' 

  .control-group
    = f.label :enabled, :class => 'control-label' 
    .controls= f.check_box :enabled, :class => 'check_box' 

  .control-group
    = f.label :randomized, :class => 'control-label' 
    .controls= f.check_box :randomized, :class => 'check_box' 
    
  .control-group
    = f.label :num_questions, :class => 'control-label' 
    .controls= f.number_field :num_questions, :class => 'number_field'
  
  .control-group
    = f.label :tag, :class => 'control-label' 
    .controls= f.text_field :tag, :class => 'text_field' 
    
  .control-group
    = f.label :name, :class => 'control-label' 
    .controls= f.text_field :name, :class => 'text_field' 
  
  .control-group
    = f.label :start_time, :class => 'control-label'   
    .controls= datetime_select :activity_schema, :start_time, :seconds => false 
    
  .control-group
    = f.label :end_time, :class => 'control-label'   
    .controls= datetime_select :activity_schema, :end_time, :seconds => false 
  
  .control-group
    = f.label :starts_every, :class => 'control-label'   
    .controls
      = f.text_field :starts_every
      minutes 

  .control-group
    = f.label :questions, :class => 'control-label' 
    - 0.upto(34) do |index|
      .controls
        = collection_select( :questions, :id, Question.all, :id, :text,            |
          {prompt: 'None', selected: @activity_schema.questions[index].try(:id) }, |
          {class: "form-control", id: "questions#{index}",                         |
          name: "activity_schema[questions][]"}  )                                 |

  .form-actions
    = f.submit nil, :class => 'btn btn-primary' 
    = link_to t('.cancel', :default => t("helpers.links.cancel")), activity_schemas_path, :class => 'btn' 

app/views/activity_schemas/edit.html.erb
<%- model_class = ActivitySchema -%>
<div class="page-header">
  <h1><%=t '.title', :default => [:'helpers.titles.edit', 'Edit %{model}'], :model => model_class.model_name.human.titleize %></h1>
</div>
<%= render :partial => 'form' %>

app/views/activity_schemas/index.html.haml
.page_header
  %h1 Activity Schemas

%table.table.table-striped
  %thead>
    %tr
      %th id
      %th Cohort
      %th Name
      %th Enabled?
      %th Randomize order?
      %th Questions
      %th Tag
      %th Updated
      %th Actions
  %tbody
    - @activity_schemas.each do |activity_schema|
      %tr
        %td= link_to activity_schema.id, activity_schema_path(activity_schema)
        %td= activity_schema.cohort.try(:name)
        %td= activity_schema.name
        %td= activity_schema.enabled
        %td= activity_schema.randomized
        %td
          %ol{:start => 0}
            - activity_schema.questions.each do |q|
              %li!= q.text.truncate(160, :separator => ' ')
        %td= activity_schema.tag
        %td= l activity_schema.updated_at
        %td
          = link_to 'Edit', edit_activity_schema_path(activity_schema), :class => 'btn btn-mini'
          = link_to 'Delete', activity_schema_path(activity_schema), :method => :delete, :data => { :confirm => 'Are you sure?'}, :class => 'btn btn-mini btn-danger'

= link_to 'New', new_activity_schema_path, :class => 'btn btn-primary'

app/views/activity_schemas/new.html.erb
<%- model_class = ActivitySchema -%>
<div class="page-header">
  <h1><%=t '.title', :default => [:'helpers.titles.new', 'New %{model}'], :model => model_class.model_name.human.titleize %></h1>
</div>
<%= render :partial => 'form' %>

app/views/activity_schemas/show.html.erb
<%- model_class = ActivitySchema -%>
<div class="page-header">
  <h1><%=t '.title', :default => model_class.model_name.human.titleize %></h1>
</div>

<dl class="dl-horizontal">
  <dt><strong><%= model_class.human_attribute_name(:cohort_id) %>:</strong></dt>
  <dd><%= @activity_schema.cohort_id %></dd>
  <dt><strong><%= model_class.human_attribute_name(:enabled) %>:</strong></dt>
  <dd><%= @activity_schema.enabled %></dd>
  <dt><strong><%= model_class.human_attribute_name(:randomized) %>:</strong></dt>
  <dd><%= @activity_schema.randomized %></dd>
  <dt><strong><%= model_class.human_attribute_name(:num_questions) %>:</strong></dt>
  <dd><%= @activity_schema.num_questions %></dd>
  <dt><strong><%= model_class.human_attribute_name(:tag) %>:</strong></dt>
  <dd><%= @activity_schema.tag %></dd>
  <dt><strong><%= model_class.human_attribute_name(:name) %>:</strong></dt>
  <dd><%= @activity_schema.name %></dd>
  <dt><strong><%= model_class.human_attribute_name(:start_time) %>:</strong></dt>
  <dd><%= @activity_schema.start_time %></dd>
  <dt><strong><%= model_class.human_attribute_name(:end_time) %>:</strong></dt>
  <dd><%= @activity_schema.end_time %></dd>
  <dt><strong><%= model_class.human_attribute_name(:starts_every) %>:</strong></dt>
  <dd><%= @activity_schema.starts_every %></dd>
  <dt><strong><%= model_class.human_attribute_name(:questions) %> selected:</strong>
  <dd><% if @activity_schema.questions.any? %>
          <% index =1 %>
          <% @activity_schema.questions.each do |elm| %>
            <%= link_to "Q#{index}: ", question_path(elm) %>
            <%== elm.text %>
            <br>
            <% index = index +1 %>
          <%end%>
      <%end%>
  </dd>

</dl>

<div class="form-actions">
  <%= link_to t('.back', :default => t("helpers.links.back")),
              activity_schemas_path, :class => 'btn'  %>
  <%= link_to t('.edit', :default => t("helpers.links.edit")),
              edit_activity_schema_path(@activity_schema), :class => 'btn' %>
  <%= link_to t('.destroy', :default => t("helpers.links.destroy")),
              activity_schema_path(@activity_schema),
              :method => 'delete',
              :data => { :confirm => t('.confirm', :default => t("helpers.links.confirm", :default => 'Are you sure?')) },
              :class => 'btn btn-danger' %>
</div>